# -*- coding: utf-8 -*-
"""Lab 4 (12190075) - EDA.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/13MUnorl4DKxL5wnhePrdxN3dlyGS58uB

#  Lab 4 - Cleaning and EDA of IMDB

# Table of Contents 
<ol start="0">
<li> Learning Objectives </li>
<li> Loading and Cleaning with Pandas</li>
<li> Asking Questions?  </li>
<li> Parsing and Completing the Dataframe  </li>
<li> EDA  </li>
<li> Determining the Best Movies </li>
<li>Trends in Popularity of Genres </li>
</ol>

## Learning Objectives

About 10000 "best movies" were fetched and parsed from IMDB. 

`imdb_top_10000.txt` contain data tabular format as a CSV file. In this lab we'll clean and further parse the data. We'll then do some exploratory data analysis to answer questions about these best books and popular genres.

By the end of this lab, you should be able to:

1. Load and systematically address missing values, ancoded as NaN values in our data set, for example, by removing observations associated with these values.

2. Parse columns in the dataframe to create new dataframe columns.
3. Create and interpret visualizations to explore the data set

### Basic EDA workflow


The basic workflow is as follows:

1. **Scrape**  data using beautiful soup and python request.
2. **Build** a DataFrame from the data (ideally, put all data in this object)
3. **Clean** the DataFrame. It should have the following properties:
    - Each row describes a single object
    - Each column describes a property of that object
    - Columns are numeric whenever appropriate
    - Columns contain atomic properties that cannot be further decomposed
4. Explore **global properties**. Use histograms, scatter plots, and aggregation functions to summarize the data.
5. Explore **group properties**. Use groupby and small multiples to compare subsets of the data.

This process transforms your data into a format which is easier to work with, gives you a basic overview of the data's properties, and likely generates several questions for you to followup in subsequent analysis.

## 1. Loading and Cleaning with Pandas
Read in the `imdb_top_10000.txt` file, examine the data, and do any necessary data cleaning.
The textfile is tab-separated, and doesn't have any column headers. We set the appropriate keywords in `pd.read_csv` to handle this

Here is a description of the columns (in order) present in this csv file:

```
imdbID: identifier for the IMDB
title: title of the movie
year: the year the movie was released.
score: Rating of the movie in the scale of 1 - 10
votes: Number of votes received for the movie
runtime: Duration of the movie in min
genres: Genre of the movie seperated by '|'
```
"""

import pandas as pd

df = pd.read_csv("imdb_top_10000.txt", delimiter = "\t")
df.head()

df = pd.read_csv("imdb_top_10000.txt", names = ["imdbID",'title','year','score', 'votes', 'runtime', 'genres'], delimiter ="\t")
df.head()

df.dtypes

df.isna().sum()

df[df.genres.isna()]

df.shape

df.dropna(subset=['genres'], inplace=True)
df.isna().sum()

df.dtypes

"""REMOVING MINS (OBJECT) FROM RUNTIME AND CONVERTING INTO INTEGER"""

#df.head()
#url = df.runtime[0]
#url

#runtime = url.split("mins.")[0]
#runtime

#def get_runtime(url):
  #runtime = url.split("mins.")[0]
  #return runtime

#df['runtime'] = df.runtime.map(get_runtime) 
#df.head()

"""## 2. Asking Questions

Which movies was rated (score) high in a particular year?

## 3. Parsing and Completing the DataFrame

There are several problems with the DataFrame at this point:

- The runtime column describes a number, but is stored as a string
- The genres column is not atomic -- it aggregates several genres together. This makes it hard, for example, to extract which movies are Comedies.
- The movie year is repeated in the title and year column

The runtime column describes a number, but is stored as a string
"""

runtime = [int(r.split(' ')[0]) for r in df.runtime]
df['runtime'] = runtime
df.head()

df.dtypes

"""The genres column is not atomic -- it aggregates several genres together. This makes it hard, for example, to extract which movies are Comedies."""

genre_set = set()
for genre in df.genres:
  genre_set.update(genre.split('|'))

len(genre_set)

#to create 24 column
#use loop by itrating genres column then iterate genres row
for genre in genre_set:
  #to create new column for genres and testing or checking the particular genres is there or not in column represented by true or false
  df[genre] = [genre in row.split("|") for row in df.genres]

df.head()

"""The movie year is repeated in the title and year column"""

df.head()
url = df.title[0]
url

title = url.split("(")[0]
title

def get_title(url):
  title = url.split("(")[0]
  return title

df['title'] = df.title.map(get_title) 
df.head()

"""## 4. EDA"""

newdf = df[['title','votes','score']]
newdf

max_score = df['score'].max()
print("Max score:", max_score)

min_score=df['score'].min()
print("Min score:", min_score)

yrdf = df.groupby("year")
dfyr = yrdf.get_group(1999)

x = dfyr.score
y = dfyr.runtime

plt.scatter(x,y)
plt.xlabel('Score')
plt.ylabel('Runtime')
plt.show()

dfyr = yrdf [['score','runtime']].mean()[:10]

plt.boxplot(dfyr.score,vert=False)
plt.show()

#Change in average score in ten years
plt.plot(dfyr.index,dfyr.score,marker='o')
plt.xticks(dfyr.index)
plt.xticks(rotation=90)
plt.xlabel("Year")
plt.ylabel("Max Score")
plt.show

"""## 5. Determining Best Movies"""

df_new= df.groupby("year")
df_new

len(df_new)

check_yr = df.groupby("year", sort=False)
check_yr

for key, valuedf in check_yr:
    highest_score = valuedf[valuedf['score'] == valuedf.score.max()]
    print(highest_score.title,highest_score.year,highest_score.score)
    break

"""we can conclude that The Shawshank Redemption(1994) is a highest rated score 9.2 in the year of 1994

## 6. Trends in Popularity of Genres
"""

genredf = df[list(genre_set)]
genredf.head()

import matplotlib.pyplot as plt
genre_result = genredf.sum()
y = genre_result.sort_values(ascending=False)[:10]
x = y.index

plt.bar(x,y)
plt.xticks(rotation=90)
plt.show()

"""Darma is most popular from 24 genres"""